# coding: utf-8

from __future__ import annotations

from datetime import date, datetime  # noqa: F401

import re  # noqa: F401
from typing import Any, Dict, List, Optional, Union, Literal  # noqa: F401

from pydantic import AnyUrl, BaseModel, EmailStr, validator, Field, Extra  # noqa: F401
from aries_cloudcontroller.model.invitation_message import InvitationMessage
from aries_cloudcontroller.model.service_decorator import ServiceDecorator


class OobRecord(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.

    OobRecord - a model defined in OpenAPI
        invi_msg_id: Invitation message identifier.
        invitation: Out of band invitation message.
        oob_id: Oob record identifier.
        state: Out of band message exchange state.
        attach_thread_id: Connection record identifier [Optional].
        connection_id: Connection record identifier [Optional].
        created_at: Time of record creation [Optional].
        our_recipient_key: Recipient key used for oob invitation [Optional].
        role: OOB Role [Optional].
        their_service: The their_service of this OobRecord [Optional].
        trace: Record trace information, based on agent configuration [Optional].
        updated_at: Time of last record update [Optional].
    """

    invi_msg_id: str
    invitation: InvitationMessage
    oob_id: str
    state: Literal[
        "initial",
        "prepare-response",
        "await-response",
        "reuse-not-accepted",
        "reuse-accepted",
        "done",
        "deleted",
    ]
    attach_thread_id: Optional[str] = None
    connection_id: Optional[str] = None
    created_at: Optional[str] = None
    our_recipient_key: Optional[str] = None
    role: Optional[Literal["sender", "receiver"]] = None
    their_service: Optional[ServiceDecorator] = None
    trace: Optional[bool] = None
    updated_at: Optional[str] = None

    @validator("created_at")
    def created_at_pattern(cls, value):
        # Property is optional
        if value is None:
            return

        pattern = r"^\d{4}-\d\d-\d\d[T ]\d\d:\d\d(?:\:(?:\d\d(?:\.\d{1,6})?))?(?:[+-]\d\d:?\d\d|Z|)$"
        if not re.match(pattern, value):
            raise ValueError(
                f"Value of created_at does not match regex pattern ('{pattern}')"
            )
        return value

    @validator("updated_at")
    def updated_at_pattern(cls, value):
        # Property is optional
        if value is None:
            return

        pattern = r"^\d{4}-\d\d-\d\d[T ]\d\d:\d\d(?:\:(?:\d\d(?:\.\d{1,6})?))?(?:[+-]\d\d:?\d\d|Z|)$"
        if not re.match(pattern, value):
            raise ValueError(
                f"Value of updated_at does not match regex pattern ('{pattern}')"
            )
        return value

    class Config:
        allow_population_by_field_name = True


OobRecord.update_forward_refs()
